// ----------------------------------------------------------------------------------------------
// Prog_name: comma_sep.c / ver 0.6
// A routine for formatting integer numbers with thousand separators,
// sign and optionally left-right alignment. 
// Created with Pelles C for Windows 6.00.4
//-----------------------------------------------------------------------------------------------
// Date: 07 july 2010
// Author: iMalc @ cprogramming forum.
//-----------------------------------------------------------------------------------------------

#include <stdio.h>
#include <stdbool.h>
#include <time.h>
// #undef getchar
// #pragma comment(lib, "\\masm32\\lib\\msvcrt.lib")

//-----------------------------------------------------------------------------------------------
// Global variables. In future versions will go into an header file
//-----------------------------------------------------------------------------------------------
    bool sign = true;              // if the number has to be displayed with sign

    bool zero = false;             // if the number is zero the function sets this
                                              // flag for its decisions
    char sep = '.';                   // here I choose the separator 
    char buffer[15] = {'\0'};        // string array for the formatted number
                                              // 10 digits max + 3 separators max + sign + NULL
    char alignment = 'L';       // choice to [R]ight-align or [L]eft-align the number  

//-----------------------------------------------------------------------------------------------
// Function prototype for iMalcsUltimateFormat(). Takes in the number to 
// format, and the pointer of the buffer to fill. Returns an int.
//-----------------------------------------------------------------------------------------------

int iMalcsUltimateFormat(long num, char []);

//-----------------------------------------------------------------------------------------------
// Function prototype for testpad(). Displays some info on the screen
// about the test we are going to perform. Returns nothing.
//-----------------------------------------------------------------------------------------------

void testpad(void);

//-----------------------------------------------------------------------------------------------

int main(void)
{
 
    int num = -1234567890;          // test number
    int cycles = 0;


    int x;                                  // generic integer counter
    clock_t start = 0;              // initial time
    clock_t stop = 0;              // end time 
    float ver = 0.6;                   // Program version
    unsigned long un = num;
 
    int times = 10000000;      // for testing performance set this number for repetitions

    printf("\n\t\t Testing version : %.2f \n",ver);
    printf("\n\t\t ---------------------------\n");
    printf("\n The value of num is: %d\n",num);
    printf("\n num after unsigned conversion is %d", un);



    start = clock();

    for (cycles = 0; cycles < times; cycles++) {
        for (x=0; x < 14; x++)
            buffer[x] = '\0'; 
        iMalcsUltimateFormat(num,buffer);
    } // end for
    
    printf("\n The formatted value of num is: %s",buffer);
    

    stop = clock();

    sign = false;
    iMalcsUltimateFormat((int)(stop-start),buffer);
    printf("\n Elapsed ClickTime: %s",buffer);
    for (x=0; x < 14; x++)
        buffer[x] = ' \0'; 

    sign = false;
    iMalcsUltimateFormat(times,buffer);
    printf("\n to perform %s",buffer);
    printf(" cycles of the formatting function");
    getchar();
    return 0;
}

//---------------------------------------------------------------
// iMalc version
//---------------------------------------------------------------
int iMalcsUltimateFormat(long snum, char s[])
{
    char *ps = s;
    unsigned long num1 = snum, num2, num3, div;
    if (snum < 0) {
        *ps++ = '-';
        num1 = -snum;
    }
    if (num1 < 10000) {
        if (num1 < 10) goto L1;
        if (num1 < 100) goto L2;
        if (num1 < 1000) goto L3;
    } else {
        num2 = num1 / 10000;
        num1 -= num2 * 10000;
        if (num2 < 10000) {
            if (num2 < 10) goto L5;
            if (num2 < 100) goto L6;
            if (num2 < 1000) goto L7;
        } else {
            num3 = num2 / 10000;
            num2 -= num3 * 10000;
            if (num3 >= 10) {
                *ps++ = '0' + (char)(div = (num3*6554UL)>>16); num3 -= div*10;
                *ps++ = ',';
            }
            *ps++ = '0' + (char)(num3);
        }
        *ps++ = '0' + (char)(div = (num2*8389UL)>>23); num2 -= div*1000;
L7:
        *ps++ = '0' + (char)(div = (num2*5243UL)>>19); num2 -= div*100;
        *ps++ = ',';
L6:
        *ps++ = '0' + (char)(div = (num2*6554UL)>>16); num2 -= div*10;
L5:
        *ps++ = '0' + (char)(num2);
    }
    *ps++ = '0' + (char)(div = (num1*8389UL)>>23); num1 -= div*1000;
    *ps++ = ',';
L3:
    *ps++ = '0' + (char)(div = (num1*5243UL)>>19); num1 -= div*100;
L2:
    *ps++ = '0' + (char)(div = (num1*6554UL)>>16); num1 -= div*10;
L1:
    *ps++ = '0' + (char)(num1);
    *ps = '\0';
    return ps - s;
}
